import type { BaseStyleProps, Circle as GCircle, CircleStyleProps, Ellipse as GEllipse, EllipseStyleProps, Group as GGroup, HTML as GHTML, HTMLStyleProps, Image as GImage, ImageStyleProps, Line as GLine, LineStyleProps, Path as GPath, PathStyleProps, Polygon as GPolygon, PolygonStyleProps, Polyline as GPolyline, PolylineStyleProps, Rect as GRect, RectStyleProps, Text as GText, TextStyleProps } from '@antv/g';
import { Shape } from '@antv/g';
import type { Key, ReactElement, ReactNode, Ref } from 'react';
import type { GEvents } from './types';
type BaseProps<Element, Prop> = {
    key?: Key;
    ref?: Ref<Element>;
    children?: ReactNode;
} & Prop & GEvents;
export declare function ElementOf<Element, Prop, T extends string>(type: T): (props: BaseProps<Element, Prop>) => ReactElement<Prop, T>;
export declare const Circle: (props: BaseProps<GCircle, CircleStyleProps>) => ReactElement<CircleStyleProps, Shape.CIRCLE>;
export declare const Ellipse: (props: BaseProps<GEllipse, EllipseStyleProps>) => ReactElement<EllipseStyleProps, Shape.ELLIPSE>;
export declare const Group: (props: BaseProps<GGroup, BaseStyleProps>) => ReactElement<BaseStyleProps, Shape.GROUP>;
export declare const HTML: (props: BaseProps<GHTML, HTMLStyleProps>) => ReactElement<HTMLStyleProps, Shape.HTML>;
export declare const Image: (props: BaseProps<GImage, ImageStyleProps>) => ReactElement<ImageStyleProps, Shape.IMAGE>;
export declare const Line: (props: BaseProps<GLine, LineStyleProps>) => ReactElement<LineStyleProps, Shape.LINE>;
export declare const Path: (props: BaseProps<GPath, PathStyleProps>) => ReactElement<PathStyleProps, Shape.PATH>;
export declare const Polygon: (props: BaseProps<GPolygon, PolygonStyleProps>) => ReactElement<PolygonStyleProps, Shape.POLYGON>;
export declare const Polyline: (props: BaseProps<GPolyline, PolylineStyleProps>) => ReactElement<PolylineStyleProps, Shape.POLYLINE>;
export declare const Rect: (props: BaseProps<GRect, RectStyleProps>) => ReactElement<RectStyleProps, Shape.RECT>;
export declare const Text: (props: BaseProps<GText, TextStyleProps>) => ReactElement<TextStyleProps, Shape.TEXT>;
export * from './components';
